#pragma sfr
#pragma ei
#pragma DI

#include "trgbios.h"

#define NULL ((void *)0)
#define SAMPLINGTIME 0x3c00			//TvO 4.096msec 244Hz
#define FOFFSET 23					//OiItZbg
#define ROFFSET 46					//ޕItZbg

short pos, oldpos, sigma;		//݈ʒuAOʒuAʒu̗ݐ
unsigned char index;		//GR[_̏ԂfR[h邽߂̋ZI
short pwmout;				//o
const char dir[] = { 0,1,-1,0,-1,0,0,1,1,0,0,-1,0,-1,1,0 }; // ]e[u
unsigned char param_P;		//QCp[^
unsigned char param_I;		//ϕQCp[^
unsigned char param_D;		//QCp[^

//l16i\֐
void itoh(short out, unsigned char pos)
{
	const unsigned char hexchar[] = {"0123456789ABCDEF"};
	char src[16];
	src[3] = hexchar[out & 0x0f];
	out = out >> 4;
	src[2] = hexchar[out & 0x0f];
	out = out >> 4;
	src[1] = hexchar[out & 0x0f];
	out = out >> 4;
	src[0] = hexchar[out & 0x0f];
	src[4] = ' ';
	src[6] = hexchar[pos & 0x0f];
	pos = pos >> 4;
	src[5] = hexchar[pos & 0x0f];
	pos = pos >> 4;
	src[7] = '\n';
	src[8] = '\0';
	trg_puts(src);
}

//GR[_ǂݎ֐
void encoder(void)
{
	static unsigned char ab;
	ab = (P1.7 << 1) + (P0.0);							//ABTvO
    index = ( (index << 2) + (ab & 3) ) & 0x0f;        	//Olƍl4bitŃCfbNXƂ
    if (dir[index]) {                       			//ʒuXV
        pos += (short)dir[index];
    }
    sigma += pos;										//ʒu̘aƂ
}

//PID֐
void pidcontrol()
{
	static unsigned char step;
	pwmout = (pos * param_P) + (sigma >> param_I) + (param_D * (pos - oldpos)); //PID䎮
	if(pwmout < 0)										//o͂̏ꍇ
	{
		P1.5 = 0;										//
		P12.0 = 1;
		pwmout -= ROFFSET;								//ItZbg
		if(pwmout <= 0xff01)
		{
			CMP11 = 0xfe;
		}
		else
		{
			CMP11 = -pwmout;
		}
	}
	else if(pwmout > 0)									//o͂̏ꍇ
	{
		P1.5 = 1;										//Oi
		P12.0 = 0;
		pwmout += FOFFSET;								//ItZbg
		if(pwmout >= 0xff)
		{
			CMP11 = 0xfe;
		}
		else
		{
			CMP11 = pwmout;
		}
	}
	else												//o0Ȃ~
	{
		CMP11 = 0;
	}
	step++;
	if(step >= 16)
	{
		oldpos = pos;
		step = 0;
	}
	itoh(pwmout,pos);									//Ԃ\
}

//e평
void init(void)
{

	PU3.0 =	1;
	PU12.0 = 1;
	
	EGP =	0x00;
	EGN =	0x02;

	PM0.0 = 1;
	PM1.4 = 1;
	PM1.5 = 0;
	PM1.6 = 0;
	PM1.7 = 1;
	PM12.0 = 0;
	
	//^C}H1̏
	TMHMD1.0 = 1;
	TMHMD1.1 = 1;
	TMHMD1.2 = 0;
	TMHMD1.3 = 1;
	TMHMD1.4 = 0;
	TMHMD1.5 = 1;
	TMHMD1.6 = 0;
	TMHMD1.7 = 0;
	CMP01 = 0xff;	//
	CMP11 = 0x80;	//
}

//16rbg^C}荞
void intsrv_tim(void)
{
	encoder();				// [^GR[_̃fR[h֐Ăяo
	pidcontrol();			// PIDPWMo
}

void main()
{
	pos = 0;
	oldpos = 0;
	pwmout = 0;
	sigma = 0;
	param_P = 1;
	param_I = 8;
	param_D = 0;
	index = (P1.7 << 1) + (P0.0);
	
	init();				//
	P1.5 = 1;			//~
	P12.0 = 1;
	TMHMD1.7 = 1;		//PWMo͊Jn
	
	trg_regintsrv(TRG_INTID_BSITM000,intsrv_tim); // 荞݃nho^

	trg_puts("PIDcontrol\n");
	
	PRM00 = 1;
	CR000 = SAMPLINGTIME;  // 荞ݎ = TvO^C
	TMC00 = 0x0C;		   // JEgJn
	MK0H.6 = 0;			   // TM000荞݋
	
	while(1)
	{
		char c;
		if(trg_getrecvcount() == 0) continue;
		
		c = trg_getc();
		
		if(c == 'z')		//_ݒp
		{
			pos = 0;
			sigma = 0;
			index = (P1.7 << 1) + (P0.0);
			P1.5 = 1;
			P12.0 = 1;
			continue;
		}
		if(c == '0')		//vOIp
		{
			P1.5 = 1;
			P12.0 = 1;
			MK0H.6 = 1;
			break;
		}
		//QC
		if(c == '1') param_P = 7;
		if(c == '2') param_P = 14;
		if(c == '3') param_P = 21;
		if(c == '4') param_P = 28;
		if(c == '5') param_P = 35;
		if(c == '6') param_P = 42;
		if(c == '7') param_P = 49;
		if(c == '8') param_P = 56;

		//ϕQC
		if(c == 'a') param_I = 7;
		if(c == 's') param_I = 6;
		if(c == 'd') param_I = 5;
		if(c == 'f') param_I = 4;
		if(c == 'g') param_I = 3;
		if(c == 'h') param_I = 2;
		if(c == 'j') param_I = 1;
		if(c == 'k') param_I = 0;

		//QC
		if(c == 'q') param_D = 1;
		if(c == 'w') param_D = 2;
		if(c == 'e') param_D = 3;
		if(c == 'r') param_D = 4;
		if(c == 't') param_D = 5;
		if(c == 'y') param_D = 6;
		if(c == 'u') param_D = 7;
		if(c == 'i') param_D = 8;
	}
	trg_regintsrv(TRG_INTID_BSITM000,NULL); // 荞݃nho^
}

